#!/bin/sh
#
# Copyright (c) 2006 Kungliga Tekniska Högskolan
# (Royal Institute of Technology, Stockholm, Sweden).
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Institute nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id$
#

top_srcdir="@top_srcdir@"
env_setup="@env_setup@"
srcdir="@srcdir@"
objdir="@objdir@"

. ${env_setup}
. ${top_srcdir}/tests/bin/test-lib.sh

# If there is no useful db support compiled in, disable test
../db/have-db || exit 77

R=TEST.H5L.SE

port=@port@

kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -A -r $R"
kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
keytabfile=${objdir}/server.keytab
keytab="FILE:${keytabfile}"

gssmask="${TESTS_ENVIRONMENT} ../../appl/gssmask/gssmask"
gssmaskn1="${gssmask} -p 8889 --spn=host/n1.test.h5l.se@${R} --logfile=n1.log --detach --pidfile=n1.pid"
gssmaskn2="${gssmask} -p 8890 --spn=host/n2.test.h5l.se@${R} --logfile=n2.log --detach --pidfile=n2.pid"
gssmaskn3="${gssmask} -p 8891 --spn=host/n3.test.h5l.se@${R} --logfile=n3.log --detach --pidfile=n3.pid"
gssmaestro="../../appl/gssmask/gssmaestro"

KRB5_CONFIG="${objdir}/krb5.conf"
export KRB5_CONFIG

KRB5CCNAME=${cache}
rm -f ${keytabfile}
rm -f current-db*
rm -f out-*
rm -f mkey.file*
rm -f n1.pid n2.pid n3.pid

test_init

test_section "Creating database"
# Test virtual principals, why not
test_run ${kadmin} <<EOF
init --realm-max-ticket-life=1day --realm-max-renewable-life=1month ${R}
add_ns --key-rotation-epoch=now      --key-rotation-period=15m     --max-ticket-life=10d         --max-renewable-life=20d      --attributes=                 "_/test.h5l.se@${R}"
ext -k ${keytab} host/n1.test.h5l.se@${R}
ext -k ${keytab} host/n2.test.h5l.se@${R}
ext -k ${keytab} host/n3.test.h5l.se@${R}
add -p u1 --use-defaults user1@${R}
check ${R}
EOF

kdcpid=
n1pid=
n2pid=
n3pid=
cleanup() {
    echo signal killing kdcs
    kill -9 ${kdcpid} ${n1pid} ${n2pid} ${n3pid} 2>/dev/null
    trap '' EXIT INT TERM
    cat messages.log
    exit 1
}
trap cleanup EXIT INT TERM

test_section "Starting kdc"
test_run ${kdc} --detach --testing
kdcpid=`getpid kdc`

test_section "Starting client 1"
test_run ${gssmaskn1} --moniker=n1
n1pid=`cat n1.pid 2>/dev/null`

test_section "Starting client 2"
test_run ${gssmaskn2} --moniker=n2
n2pid=`cat n2.pid 2>/dev/null`

test_section "Starting client 3"
${gssmaskn3} --moniker=n3 || { echo "gssmask n3 failed to start"; exit 1; }
n3pid=`cat n3.pid 2>/dev/null`

#    --wrap-ext

test_section "Running gssmaestro"
test_run ${gssmaestro} \
    --slaves=localhost:8889 \
    --slaves=localhost:8890 \
    --slaves=localhost:8891 \
    --principals=user1@${R}:u1

trap "" EXIT

echo "killing kdc and clients (${kdcpid}, ${n1pid}, ${n2pid}, ${n3pid})"
kill ${kdcpid} ${n1pid} ${n2pid} ${n3pid} 2> /dev/null

test_finish
exit $?
